// 2007/09/15 Hiroyuki Ogasawara
// vim:ts=4 sw=4:
// Hello world!
//  http://dench.flatlib.jp/
//  http://wlog.flatlib.jp/


const float4	TextColor= float4( 1, 1, 1, 1 );
const float4	BGColor= float4( 0, 0, 1, 1 );
const uint		FontSize= 32;


//-----------------------------------------------------------------------------

float4x4	WorldToProjection;
Texture2D	FontTexture;
float3		Locate;

SamplerState	samplerstate
{
};

//-----------------------------------------------------------------------------

struct VS_OUTPUT {
	int		Locate	: VID;
	int		Code	: CODE;
};

struct GS_OUTPUT {
	float4	Pos		: SV_POSITION;
	float2	UV		: TEXCOORD;
};

//-----------------------------------------------------------------------------

/*!
	@brief
		ɉ܂B

	code ɂ͕`敶 ascii R[h 1܂B
*/
VS_OUTPUT VS_Main( uint code : CODE, uint vid : SV_VertexID )
{
	VS_OUTPUT	Out;
	Out.Locate= vid;
	Out.Code= code;
	return	Out;
}

//-----------------------------------------------------------------------------

const float3	posmap[4]= {
	{	-0.5,	 1.0,	0,	},
	{	 0.5,	 1.0,	0,	},
	{	-0.5,	-1.0,	0,	},
	{	 0.5,	-1.0,	0,	},
};

const float2	uvmap[4]= {
	{	0,		0,	},
	{	0.5,	0,	},
	{	0,		1,	},
	{	0.5,	1,	},
};


/*!
	@brief
		R[h|S܂B

	tHgeNX` 16x16  2D zz肵Ă܂B
*/
[maxvertexcount(6)]
void GS_Main( point VS_OUTPUT In[1] : POSITION,
				inout TriangleStream<GS_OUTPUT> gsstream )
{
	float3		pos= Locate + float3( In[0].Locate, 0, 0 );
	float2		uv= float2( In[0].Code & 15, In[0].Code >>4 );
	GS_OUTPUT	op[4];
	for( int i= 0 ; i< 4 ; i++ ){
		op[i].Pos= mul( float4( pos + posmap[i], 1 ), WorldToProjection );
		op[i].UV= uv + uvmap[i];
	}
	gsstream.Append( op[0] );
	gsstream.Append( op[1] );
	gsstream.Append( op[2] );
	gsstream.RestartStrip();
	gsstream.Append( op[2] );
	gsstream.Append( op[1] );
	gsstream.Append( op[3] );
	gsstream.RestartStrip();
}

//-----------------------------------------------------------------------------

/*!
	@brief
		`悵Ă܂

	BGƂ̃J[uhAUVl̕␳s܂B
	Xe[gݒĂȂ߁B蔲B
*/
float4 PS_Main( GS_OUTPUT In ) : SV_Target
{
	float2	imagesize;
	FontTexture.GetDimensions( imagesize.x, imagesize.y );
	return	lerp( TextColor, BGColor,
				FontTexture.Sample( samplerstate,
					In.UV * 1/imagesize * FontSize ).x );
}

//-----------------------------------------------------------------------------

technique10 Main
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS_Main() ) );
		SetGeometryShader( CompileShader( gs_4_0, GS_Main() ) );
		SetPixelShader( CompileShader( ps_4_0, PS_Main() ) );
	}
}


//-----------------------------------------------------------------------------

